=== modified file 'cmake/os/FreeBSD.cmake'
--- cmake/os/FreeBSD.cmake	2010-06-23 14:19:19 +0000
+++ cmake/os/FreeBSD.cmake	2011-12-10 18:32:32 +0000
@@ -22,3 +22,10 @@
 
 # The below was used for really old versions of FreeBSD, roughly: before 5.1.9
 # ADD_DEFINITIONS(-DHAVE_BROKEN_REALPATH)
+
+# Use atomic builtins
+IF(CMAKE_SIZEOF_VOID_P EQUAL 4 AND CMAKE_SYSTEM_PROCESSOR STREQUAL "i386")
+  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=i686")		
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=i686")		
+  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -march=i686")
+ENDIF()

=== modified file 'cmake/os/Linux.cmake'
--- cmake/os/Linux.cmake	2011-11-03 22:39:53 +0000
+++ cmake/os/Linux.cmake	2011-12-26 00:08:07 +0000
@@ -46,3 +46,10 @@
   SET(HUGETLB_USE_PROC_MEMINFO 1)
   SET(HAVE_LARGE_PAGE_OPTION 1)
 ENDIF()
+
+IF(CMAKE_SIZEOF_VOID_P EQUAL 4 AND CMAKE_SYSTEM_PROCESSOR MATCHES "86")
+  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=i686")
+  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=i686")
+  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -march=i686")
+ENDIF()
+

=== modified file 'include/thr_alarm.h'
--- include/thr_alarm.h	2011-11-03 18:17:05 +0000
+++ include/thr_alarm.h	2011-12-10 18:32:32 +0000
@@ -40,7 +40,11 @@
 } ALARM_INFO;
 
 void thr_alarm_info(ALARM_INFO *info);
+extern my_bool my_disable_thr_alarm;
 
+#ifdef _WIN32
+#define DONT_USE_THR_ALARM
+#endif
 #if defined(DONT_USE_THR_ALARM)
 
 #define USE_ALARM_THREAD
@@ -88,7 +92,7 @@
 
 extern uint thr_client_alarm;
 extern pthread_t alarm_thread;
-extern my_bool my_disable_thr_alarm;
+
 
 #define thr_alarm_init(A) (*(A))=0
 #define thr_alarm_in_use(A) (*(A)!= 0)

=== modified file 'include/violite.h'
--- include/violite.h	2011-11-03 18:17:05 +0000
+++ include/violite.h	2011-12-10 18:32:32 +0000
@@ -168,6 +168,7 @@
 #define vio_should_retry(vio) 			(vio)->should_retry(vio)
 #define vio_was_interrupted(vio) 		(vio)->was_interrupted(vio)
 #define vio_close(vio)				((vio)->vioclose)(vio)
+#define vio_shutdown(vio,how)			((vio)->shutdown)(vio,how)
 #define vio_peer_addr(vio, buf, prt, buflen)	(vio)->peer_addr(vio, buf, prt, buflen)
 #define vio_timeout(vio, which, seconds)	(vio)->timeout(vio, which, seconds)
 #define vio_poll_read(vio, timeout)             (vio)->poll_read(vio, timeout)
@@ -219,6 +220,7 @@
   void	  (*timeout)(Vio*, unsigned int which, unsigned int timeout);
   my_bool (*poll_read)(Vio *vio, uint timeout);
   my_bool (*is_connected)(Vio*);
+  int (*shutdown)(Vio *, int);
   my_bool (*has_data) (Vio*);
 #ifdef HAVE_OPENSSL
   void	  *ssl_arg;
@@ -235,6 +237,7 @@
   char    *shared_memory_pos;
 #endif /* HAVE_SMEM */
 #ifdef _WIN32
+  DWORD thread_id; /* Used to XP only in vio_shutdown */
   OVERLAPPED pipe_overlapped;
   DWORD read_timeout_ms;
   DWORD write_timeout_ms;

=== modified file 'mysql-test/include/mysqld--help.inc'
--- mysql-test/include/mysqld--help.inc	2011-12-02 13:38:05 +0000
+++ mysql-test/include/mysqld--help.inc	2011-12-20 21:36:06 +0000
@@ -18,11 +18,11 @@
   # their paths may vary:
   @skipvars=qw/basedir open-files-limit general-log-file log plugin-dir
                log-slow-queries pid-file slow-query-log-file log-basename
-               datadir slave-load-tmpdir tmpdir socket/;
+               datadir slave-load-tmpdir tmpdir socket /;
 
   # Plugins which may or may not be there:
   @plugins=qw/innodb ndb archive blackhole federated partition ndbcluster feedback debug temp-pool ssl des-key-file
-              xtradb thread-concurrency super-large-pages mutex-deadlock-detector null-audit maria aria pbxt oqgraph sphinx/;
+              xtradb thread-concurrency super-large-pages mutex-deadlock-detector null-audit maria aria pbxt oqgraph sphinx thread-handling thread-pool/;
 
   # And substitute the content some environment variables with their
   # names:

=== modified file 'mysql-test/mysql-test-run.pl'
--- mysql-test/mysql-test-run.pl	2011-12-15 21:07:58 +0000
+++ mysql-test/mysql-test-run.pl	2011-12-26 15:39:04 +0000
@@ -3466,7 +3466,9 @@
   mtr_add_arg($args, "--loose-skip-ndbcluster");
   mtr_add_arg($args, "--loose-skip-aria");
   mtr_add_arg($args, "--disable-sync-frm");
-  mtr_add_arg($args, "--tmpdir=%s", "$opt_vardir/tmp/");
+  mtr_add_arg($args, "--tmpdir=.");
+  mtr_add_arg($args, "--max_allowed_packet=8M");
+  mtr_add_arg($args, "--net_buffer_length=16K");
   mtr_add_arg($args, "--core-file");
 
   if ( $opt_debug )

=== modified file 'mysql-test/r/mysqld--help-notwin.result'
--- mysql-test/r/mysqld--help-notwin.result	2011-12-12 22:58:40 +0000
+++ mysql-test/r/mysqld--help-notwin.result	2011-12-26 15:39:04 +0000
@@ -794,9 +794,6 @@
  values are COMMIT or ROLLBACK.
  --thread-cache-size=# 
  How many threads we should keep in a cache for reuse
- --thread-handling=name 
- Define threads usage for handling queries, one of
- one-thread-per-connection, no-threads
  --thread-stack=#    The stack size for each thread
  --time-format=name  The TIME format (ignored)
  --timed-mutexes     Specify whether to time mutexes (only InnoDB mutexes are
@@ -935,7 +932,7 @@
 master-info-file master.info
 master-retry-count 86400
 master-verify-checksum FALSE
-max-allowed-packet 1048576
+max-allowed-packet 8388608
 max-binlog-cache-size 18446744073709547520
 max-binlog-size 1073741824
 max-binlog-stmt-cache-size 18446744073709547520
@@ -946,7 +943,7 @@
 max-heap-table-size 16777216
 max-join-size 18446744073709551615
 max-length-for-sort-data 1024
-max-long-data-size 1048576
+max-long-data-size 8388608
 max-prepared-stmt-count 16382
 max-relay-log-size 0
 max-seeks-for-key 18446744073709551615
@@ -1062,7 +1059,6 @@
 table-open-cache 400
 tc-heuristic-recover COMMIT
 thread-cache-size 0
-thread-handling one-thread-per-connection
 thread-stack 294912
 time-format %H:%i:%s
 timed-mutexes FALSE

=== modified file 'mysql-test/r/mysqld--help-win.result'
--- mysql-test/r/mysqld--help-win.result	2011-11-28 16:48:19 +0000
+++ mysql-test/r/mysqld--help-win.result	2011-12-20 22:20:14 +0000
@@ -817,9 +817,6 @@
  (Defaults to on; use --skip-thread-alarm to disable.)
  --thread-cache-size=# 
  How many threads we should keep in a cache for reuse
- --thread-handling=name 
- Define threads usage for handling queries, one of
- one-thread-per-connection, no-threads
  --thread-stack=#    The stack size for each thread
  --time-format=name  The TIME format (ignored)
  --timed-mutexes     Specify whether to time mutexes (only InnoDB mutexes are
@@ -959,7 +956,7 @@
 master-info-file master.info
 master-retry-count 86400
 master-verify-checksum FALSE
-max-allowed-packet 1048576
+max-allowed-packet 8388608
 max-binlog-cache-size 18446744073709547520
 max-binlog-dump-events 0
 max-binlog-size 1073741824
@@ -971,7 +968,7 @@
 max-heap-table-size 16777216
 max-join-size 18446744073709551615
 max-length-for-sort-data 1024
-max-long-data-size 1048576
+max-long-data-size 8388608
 max-prepared-stmt-count 16382
 max-relay-log-size 0
 max-seeks-for-key 18446744073709551615
@@ -1093,7 +1090,6 @@
 tc-heuristic-recover COMMIT
 thread-alarm TRUE
 thread-cache-size 0
-thread-handling one-thread-per-connection
 thread-stack 294912
 time-format %H:%i:%s
 timed-mutexes FALSE

=== modified file 'mysql-test/r/pool_of_threads.result'
--- mysql-test/r/pool_of_threads.result	2010-10-18 20:33:05 +0000
+++ mysql-test/r/pool_of_threads.result	2011-12-20 21:36:06 +0000
@@ -2084,10 +2084,10 @@
 show full columns from t2 from test like 's%';
 Field	Type	Collation	Null	Key	Default	Extra	Privileges	Comment
 show keys from t2;
-Table	Non_unique	Key_name	Seq_in_index	Column_name	Collation	Cardinality	Sub_part	Packed	Null	Index_type	Comment
-t2	0	PRIMARY	1	auto	A	1199	NULL	NULL		BTREE	
-t2	0	fld1	1	fld1	A	1199	NULL	NULL		BTREE	
-t2	1	fld3	1	fld3	A	NULL	NULL	NULL		BTREE	
+Table	Non_unique	Key_name	Seq_in_index	Column_name	Collation	Cardinality	Sub_part	Packed	Null	Index_type	Comment	Index_comment
+t2	0	PRIMARY	1	auto	A	1199	NULL	NULL		BTREE		
+t2	0	fld1	1	fld1	A	1199	NULL	NULL		BTREE		
+t2	1	fld3	1	fld3	A	NULL	NULL	NULL		BTREE		
 drop table t4, t3, t2, t1;
 CREATE TABLE t1 (
 cont_nr int(11) NOT NULL auto_increment,
@@ -2153,7 +2153,7 @@
 drop table t1;
 SELECT sleep(5);
 SELECT sleep(5);
-# -- Success: more than --thread-pool-size normal connections not possible
+# -- Success: more than --thread_pool_max_threads normal connections not possible
 sleep(5)
 0
 sleep(5)

=== added file 'mysql-test/suite/sys_vars/r/thread_pool_idle_timeout_basic.result'
--- mysql-test/suite/sys_vars/r/thread_pool_idle_timeout_basic.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/r/thread_pool_idle_timeout_basic.result	2011-12-20 21:36:06 +0000
@@ -0,0 +1,47 @@
+SET @start_global_value = @@global.thread_pool_idle_timeout;
+select @@global.thread_pool_idle_timeout;
+@@global.thread_pool_idle_timeout
+60
+select @@session.thread_pool_idle_timeout;
+ERROR HY000: Variable 'thread_pool_idle_timeout' is a GLOBAL variable
+show global variables like 'thread_pool_idle_timeout';
+Variable_name	Value
+thread_pool_idle_timeout	60
+show session variables like 'thread_pool_idle_timeout';
+Variable_name	Value
+thread_pool_idle_timeout	60
+select * from information_schema.global_variables where variable_name='thread_pool_idle_timeout';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_IDLE_TIMEOUT	60
+select * from information_schema.session_variables where variable_name='thread_pool_idle_timeout';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_IDLE_TIMEOUT	60
+set global thread_pool_idle_timeout=60;
+select @@global.thread_pool_idle_timeout;
+@@global.thread_pool_idle_timeout
+60
+set global thread_pool_idle_timeout=4294967295;
+select @@global.thread_pool_idle_timeout;
+@@global.thread_pool_idle_timeout
+4294967295
+set session thread_pool_idle_timeout=1;
+ERROR HY000: Variable 'thread_pool_idle_timeout' is a GLOBAL variable and should be set with SET GLOBAL
+set global thread_pool_idle_timeout=1.1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_idle_timeout'
+set global thread_pool_idle_timeout=1e1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_idle_timeout'
+set global thread_pool_idle_timeout="foo";
+ERROR 42000: Incorrect argument type to variable 'thread_pool_idle_timeout'
+set global thread_pool_idle_timeout=-1;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_idle_timeout value: '-1'
+select @@global.thread_pool_idle_timeout;
+@@global.thread_pool_idle_timeout
+1
+set global thread_pool_idle_timeout=10000000000;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_idle_timeout value: '10000000000'
+select @@global.thread_pool_idle_timeout;
+@@global.thread_pool_idle_timeout
+4294967295
+SET @@global.thread_pool_idle_timeout = @start_global_value;

=== added file 'mysql-test/suite/sys_vars/r/thread_pool_max_threads_basic.result'
--- mysql-test/suite/sys_vars/r/thread_pool_max_threads_basic.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/r/thread_pool_max_threads_basic.result	2011-12-20 23:30:02 +0000
@@ -0,0 +1,47 @@
+SET @start_global_value = @@global.thread_pool_max_threads;
+select @@global.thread_pool_max_threads;
+@@global.thread_pool_max_threads
+500
+select @@session.thread_pool_max_threads;
+ERROR HY000: Variable 'thread_pool_max_threads' is a GLOBAL variable
+show global variables like 'thread_pool_max_threads';
+Variable_name	Value
+thread_pool_max_threads	500
+show session variables like 'thread_pool_max_threads';
+Variable_name	Value
+thread_pool_max_threads	500
+select * from information_schema.global_variables where variable_name='thread_pool_max_threads';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_MAX_THREADS	500
+select * from information_schema.session_variables where variable_name='thread_pool_max_threads';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_MAX_THREADS	500
+set global thread_pool_max_threads=1;
+select @@global.thread_pool_max_threads;
+@@global.thread_pool_max_threads
+1
+set global thread_pool_max_threads=65536;
+select @@global.thread_pool_max_threads;
+@@global.thread_pool_max_threads
+65536
+set session thread_pool_max_threads=1;
+ERROR HY000: Variable 'thread_pool_max_threads' is a GLOBAL variable and should be set with SET GLOBAL
+set global thread_pool_max_threads=1.1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_max_threads'
+set global thread_pool_max_threads=1e1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_max_threads'
+set global thread_pool_max_threads="foo";
+ERROR 42000: Incorrect argument type to variable 'thread_pool_max_threads'
+set global thread_pool_max_threads=0;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_max_threads value: '0'
+select @@global.thread_pool_max_threads;
+@@global.thread_pool_max_threads
+1
+set global thread_pool_max_threads=10000000000;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_max_threads value: '10000000000'
+select @@global.thread_pool_max_threads;
+@@global.thread_pool_max_threads
+65536
+SET @@global.thread_pool_max_threads = @start_global_value;

=== added file 'mysql-test/suite/sys_vars/r/thread_pool_size_basic.result'
--- mysql-test/suite/sys_vars/r/thread_pool_size_basic.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/r/thread_pool_size_basic.result	2011-12-20 21:36:06 +0000
@@ -0,0 +1,41 @@
+SET @start_global_value = @@global.thread_pool_size;
+select @@global.thread_pool_size;
+@@global.thread_pool_size
+1
+select @@session.thread_pool_size;
+ERROR HY000: Variable 'thread_pool_size' is a GLOBAL variable
+show global variables like 'thread_pool_size';
+Variable_name	Value
+thread_pool_size	#
+show session variables like 'thread_pool_size';
+Variable_name	Value
+thread_pool_size	#
+select * from information_schema.global_variables where variable_name='thread_pool_size';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_SIZE	#
+select * from information_schema.session_variables where variable_name='thread_pool_size';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_SIZE	#
+set global thread_pool_size=1;
+select @@global.thread_pool_size;
+@@global.thread_pool_size
+1
+set global thread_pool_size=128;
+select @@global.thread_pool_size;
+@@global.thread_pool_size
+128
+set session thread_pool_size=1;
+ERROR HY000: Variable 'thread_pool_size' is a GLOBAL variable and should be set with SET GLOBAL
+set global thread_pool_size=1.1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_size'
+set global thread_pool_size=1e1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_size'
+set global thread_pool_size="foo";
+ERROR 42000: Incorrect argument type to variable 'thread_pool_size'
+set global thread_pool_size=-1;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_size value: '-1'
+set global thread_pool_size=100000;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_size value: '100000'
+SET @@global.thread_pool_size = @start_global_value;

=== added file 'mysql-test/suite/sys_vars/r/thread_pool_stall_limit_basic.result'
--- mysql-test/suite/sys_vars/r/thread_pool_stall_limit_basic.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/r/thread_pool_stall_limit_basic.result	2011-12-20 21:36:06 +0000
@@ -0,0 +1,47 @@
+SET @start_global_value = @@global.thread_pool_stall_limit;
+select @@global.thread_pool_stall_limit;
+@@global.thread_pool_stall_limit
+500
+select @@session.thread_pool_stall_limit;
+ERROR HY000: Variable 'thread_pool_stall_limit' is a GLOBAL variable
+show global variables like 'thread_pool_stall_limit';
+Variable_name	Value
+thread_pool_stall_limit	500
+show session variables like 'thread_pool_stall_limit';
+Variable_name	Value
+thread_pool_stall_limit	500
+select * from information_schema.global_variables where variable_name='thread_pool_stall_limit';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_STALL_LIMIT	500
+select * from information_schema.session_variables where variable_name='thread_pool_stall_limit';
+VARIABLE_NAME	VARIABLE_VALUE
+THREAD_POOL_STALL_LIMIT	500
+set global thread_pool_stall_limit=60;
+select @@global.thread_pool_stall_limit;
+@@global.thread_pool_stall_limit
+60
+set global thread_pool_stall_limit=4294967295;
+select @@global.thread_pool_stall_limit;
+@@global.thread_pool_stall_limit
+4294967295
+set session thread_pool_stall_limit=1;
+ERROR HY000: Variable 'thread_pool_stall_limit' is a GLOBAL variable and should be set with SET GLOBAL
+set global thread_pool_stall_limit=1.1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_stall_limit'
+set global thread_pool_stall_limit=1e1;
+ERROR 42000: Incorrect argument type to variable 'thread_pool_stall_limit'
+set global thread_pool_stall_limit="foo";
+ERROR 42000: Incorrect argument type to variable 'thread_pool_stall_limit'
+set global thread_pool_stall_limit=-1;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_stall_limit value: '-1'
+select @@global.thread_pool_stall_limit;
+@@global.thread_pool_stall_limit
+60
+set global thread_pool_stall_limit=10000000000;
+Warnings:
+Warning	1292	Truncated incorrect thread_pool_stall_limit value: '10000000000'
+select @@global.thread_pool_stall_limit;
+@@global.thread_pool_stall_limit
+4294967295
+set @@global.thread_pool_stall_limit = @start_global_value;

=== modified file 'mysql-test/suite/sys_vars/t/slow_launch_time_func.test'
--- mysql-test/suite/sys_vars/t/slow_launch_time_func.test	2011-01-14 08:28:23 +0000
+++ mysql-test/suite/sys_vars/t/slow_launch_time_func.test	2011-12-20 21:36:06 +0000
@@ -29,10 +29,7 @@
 #
 # Setup
 #
-
---source include/not_embedded.inc
---source include/not_threadpool.inc
-
+--source include/one_thread_per_connection.inc
 SET @global_slow_launch_time = @@GLOBAL.slow_launch_time;
 
 --echo ** Connection default **

=== modified file 'mysql-test/suite/sys_vars/t/thread_cache_size_func.test'
--- mysql-test/suite/sys_vars/t/thread_cache_size_func.test	2011-01-14 08:28:23 +0000
+++ mysql-test/suite/sys_vars/t/thread_cache_size_func.test	2011-12-20 21:36:06 +0000
@@ -27,9 +27,8 @@
 # Setup
 #
 
---source include/not_embedded.inc
---source include/not_threadpool.inc
 
+--source include/one_thread_per_connection.inc
 SET @global_thread_cache_size = @@GLOBAL.thread_cache_size;
 
 FLUSH STATUS;

=== added file 'mysql-test/suite/sys_vars/t/thread_pool_idle_timeout_basic.test'
--- mysql-test/suite/sys_vars/t/thread_pool_idle_timeout_basic.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/t/thread_pool_idle_timeout_basic.test	2011-12-20 23:52:58 +0000
@@ -0,0 +1,42 @@
+# uint global
+--source include/not_windows.inc
+SET @start_global_value = @@global.thread_pool_idle_timeout;
+
+#
+# exists as global only
+#
+select @@global.thread_pool_idle_timeout;
+--error ER_INCORRECT_GLOBAL_LOCAL_VAR
+select @@session.thread_pool_idle_timeout;
+show global variables like 'thread_pool_idle_timeout';
+show session variables like 'thread_pool_idle_timeout';
+select * from information_schema.global_variables where variable_name='thread_pool_idle_timeout';
+select * from information_schema.session_variables where variable_name='thread_pool_idle_timeout';
+
+#
+# show that it's writable
+#
+set global thread_pool_idle_timeout=60;
+select @@global.thread_pool_idle_timeout;
+set global thread_pool_idle_timeout=4294967295;
+select @@global.thread_pool_idle_timeout;
+--error ER_GLOBAL_VARIABLE
+set session thread_pool_idle_timeout=1;
+
+#
+# incorrect types
+#
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_idle_timeout=1.1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_idle_timeout=1e1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_idle_timeout="foo";
+
+
+set global thread_pool_idle_timeout=-1;
+select @@global.thread_pool_idle_timeout;
+set global thread_pool_idle_timeout=10000000000;
+select @@global.thread_pool_idle_timeout;
+
+SET @@global.thread_pool_idle_timeout = @start_global_value;

=== added file 'mysql-test/suite/sys_vars/t/thread_pool_max_threads_basic.test'
--- mysql-test/suite/sys_vars/t/thread_pool_max_threads_basic.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/t/thread_pool_max_threads_basic.test	2011-12-20 23:29:52 +0000
@@ -0,0 +1,42 @@
+# uint global
+
+SET @start_global_value = @@global.thread_pool_max_threads;
+
+#
+# exists as global only
+#
+select @@global.thread_pool_max_threads;
+--error ER_INCORRECT_GLOBAL_LOCAL_VAR
+select @@session.thread_pool_max_threads;
+show global variables like 'thread_pool_max_threads';
+show session variables like 'thread_pool_max_threads';
+select * from information_schema.global_variables where variable_name='thread_pool_max_threads';
+select * from information_schema.session_variables where variable_name='thread_pool_max_threads';
+
+#
+# show that it's writable
+#
+set global thread_pool_max_threads=1;
+select @@global.thread_pool_max_threads;
+set global thread_pool_max_threads=65536;
+select @@global.thread_pool_max_threads;
+--error ER_GLOBAL_VARIABLE
+set session thread_pool_max_threads=1;
+
+#
+# incorrect types
+#
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_max_threads=1.1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_max_threads=1e1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_max_threads="foo";
+
+
+set global thread_pool_max_threads=0;
+select @@global.thread_pool_max_threads;
+set global thread_pool_max_threads=10000000000;
+select @@global.thread_pool_max_threads;
+
+SET @@global.thread_pool_max_threads = @start_global_value;

=== added file 'mysql-test/suite/sys_vars/t/thread_pool_size_basic.test'
--- mysql-test/suite/sys_vars/t/thread_pool_size_basic.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/t/thread_pool_size_basic.test	2011-12-20 23:52:50 +0000
@@ -0,0 +1,46 @@
+# uint global
+--source include/not_windows.inc
+SET @start_global_value = @@global.thread_pool_size;
+
+#
+# exists as global only
+#
+--replace_column 2 #
+select @@global.thread_pool_size;
+--error ER_INCORRECT_GLOBAL_LOCAL_VAR
+select @@session.thread_pool_size;
+--replace_column 2 #
+show global variables like 'thread_pool_size';
+--replace_column 2 #
+show session variables like 'thread_pool_size';
+--replace_column 2 #
+select * from information_schema.global_variables where variable_name='thread_pool_size';
+--replace_column 2 #
+select * from information_schema.session_variables where variable_name='thread_pool_size';
+--replace_column 2 #
+
+#
+# show that it's writable
+#
+set global thread_pool_size=1;
+select @@global.thread_pool_size;
+set global thread_pool_size=128;
+select @@global.thread_pool_size;
+--error ER_GLOBAL_VARIABLE
+set session thread_pool_size=1;
+
+#
+# incorrect types
+#
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_size=1.1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_size=1e1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_size="foo";
+
+set global thread_pool_size=-1;
+
+set global thread_pool_size=100000;
+
+SET @@global.thread_pool_size = @start_global_value;

=== added file 'mysql-test/suite/sys_vars/t/thread_pool_stall_limit_basic.test'
--- mysql-test/suite/sys_vars/t/thread_pool_stall_limit_basic.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/sys_vars/t/thread_pool_stall_limit_basic.test	2011-12-20 23:53:07 +0000
@@ -0,0 +1,42 @@
+# uint global
+--source include/not_windows.inc
+SET @start_global_value = @@global.thread_pool_stall_limit;
+
+#
+# exists as global only
+#
+select @@global.thread_pool_stall_limit;
+--error ER_INCORRECT_GLOBAL_LOCAL_VAR
+select @@session.thread_pool_stall_limit;
+show global variables like 'thread_pool_stall_limit';
+show session variables like 'thread_pool_stall_limit';
+select * from information_schema.global_variables where variable_name='thread_pool_stall_limit';
+select * from information_schema.session_variables where variable_name='thread_pool_stall_limit';
+
+#
+# show that it's writable
+#
+set global thread_pool_stall_limit=60;
+select @@global.thread_pool_stall_limit;
+set global thread_pool_stall_limit=4294967295;
+select @@global.thread_pool_stall_limit;
+--error ER_GLOBAL_VARIABLE
+set session thread_pool_stall_limit=1;
+
+#
+# incorrect types
+#
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_stall_limit=1.1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_stall_limit=1e1;
+--error ER_WRONG_TYPE_FOR_VAR
+set global thread_pool_stall_limit="foo";
+
+
+set global thread_pool_stall_limit=-1;
+select @@global.thread_pool_stall_limit;
+set global thread_pool_stall_limit=10000000000;
+select @@global.thread_pool_stall_limit;
+
+set @@global.thread_pool_stall_limit = @start_global_value;

=== modified file 'mysql-test/t/pool_of_threads.cnf'
--- mysql-test/t/pool_of_threads.cnf	2011-07-10 17:47:24 +0000
+++ mysql-test/t/pool_of_threads.cnf	2011-12-20 21:36:06 +0000
@@ -2,7 +2,8 @@
 
 [mysqld.1]
 loose-thread-handling=   pool-of-threads
-loose-thread_pool_size=  2
+loose-thread_pool_size=  1
+loose-thread_pool_max_threads=  2
 extra-port=        @ENV.MASTER_EXTRA_PORT
 extra-max-connections=1
 

=== modified file 'mysql-test/t/pool_of_threads.test'
--- mysql-test/t/pool_of_threads.test	2011-01-03 14:33:39 +0000
+++ mysql-test/t/pool_of_threads.test	2011-12-20 21:36:06 +0000
@@ -13,7 +13,7 @@
 # connections on the extra port.
 
 # First set two connections running, and check that extra connection
-# on normal port fails due to--thread-pool-size=2
+# on normal port fails due to--thread-pool-max_threads=2
 connection default;
 send SELECT sleep(5);
 
@@ -32,11 +32,11 @@
 let $error = $mysql_errno;
 if (!$error)
 {
-  --echo # -- Error: managed to establish more than --thread-pool-size connections
+  --echo # -- Error: managed to establish more than --thread_pool_max_threads connections
 }
 if ($error)
 {
-  --echo # -- Success: more than --thread-pool-size normal connections not possible
+  --echo # -- Success: more than --thread_pool_max_threads normal connections not possible
 }
 
 connection default;

=== modified file 'mysql-test/t/wait_timeout.test'
--- mysql-test/t/wait_timeout.test	2010-10-19 11:54:28 +0000
+++ mysql-test/t/wait_timeout.test	2011-12-10 18:32:32 +0000
@@ -8,7 +8,7 @@
 ###############################################################################
 # These tests cannot run with the embedded server
 -- source include/not_embedded.inc
--- source include/one_thread_per_connection.inc
+#-- source include/one_thread_per_connection.inc
 
 # Save the initial number of concurrent sessions
 --source include/count_sessions.inc

=== modified file 'mysql-test/t/xa.test'
--- mysql-test/t/xa.test	2011-07-02 20:12:12 +0000
+++ mysql-test/t/xa.test	2011-12-20 21:36:06 +0000
@@ -358,6 +358,7 @@
   AND info = "INSERT INTO t2 SELECT a FROM t1";
 --echo # Waiting until INSERT ... is blocked
 --source include/wait_condition.inc
+--sleep 0.1
 DELETE FROM t1;
 COMMIT;
 

=== modified file 'mysys/thr_alarm.c'
--- mysys/thr_alarm.c	2011-11-03 18:17:05 +0000
+++ mysys/thr_alarm.c	2011-12-10 18:32:32 +0000
@@ -597,93 +597,6 @@
   return 0;					/* Impossible */
 }
 #endif /* USE_ALARM_THREAD */
-
-/*****************************************************************************
-  thr_alarm for win95
-*****************************************************************************/
-
-#else /* __WIN__ */
-
-void thr_alarm_kill(my_thread_id thread_id)
-{
-  /* Can't do this yet */
-}
-
-sig_handler process_alarm(int sig __attribute__((unused)))
-{
-  /* Can't do this yet */
-}
-
-
-my_bool thr_alarm(thr_alarm_t *alrm, uint sec, ALARM *alarm)
-{
-  (*alrm)= &alarm->alarmed;
-  if (alarm_aborted)
-  {
-    alarm->alarmed.crono=0;
-    return 1;
-  }
-  if (!(alarm->alarmed.crono=SetTimer((HWND) NULL,0, sec*1000,
-				      (TIMERPROC) NULL)))
-    return 1;
-  return 0;
-}
-
-
-my_bool thr_got_alarm(thr_alarm_t *alrm_ptr)
-{
-  thr_alarm_t alrm= *alrm_ptr;
-  MSG msg;
-  if (alrm->crono)
-  {
-    PeekMessage(&msg,NULL,WM_TIMER,WM_TIMER,PM_REMOVE) ;
-    if (msg.message == WM_TIMER || alarm_aborted)
-    {
-      KillTimer(NULL, alrm->crono);
-      alrm->crono = 0;
-    }
-  }
-  return !alrm->crono || alarm_aborted;
-}
-
-
-void thr_end_alarm(thr_alarm_t *alrm_ptr)
-{
-  thr_alarm_t alrm= *alrm_ptr;
-  /* alrm may be zero if thr_alarm aborted with an error */
-  if (alrm && alrm->crono)
-
-  {
-    KillTimer(NULL, alrm->crono);
-    alrm->crono = 0;
-  }
-}
-
-void end_thr_alarm(my_bool free_structures)
-{
-  DBUG_ENTER("end_thr_alarm");
-  alarm_aborted=1;				/* No more alarms */
-  DBUG_VOID_RETURN;
-}
-
-void init_thr_alarm(uint max_alarm)
-{
-  DBUG_ENTER("init_thr_alarm");
-  alarm_aborted=0;				/* Yes, Gimmie alarms */
-  DBUG_VOID_RETURN;
-}
-
-void thr_alarm_info(ALARM_INFO *info)
-{
-  bzero((char*) info, sizeof(*info));
-}
-
-void resize_thr_alarm(uint max_alarms)
-{
-}
-
-#endif /* __WIN__ */
-
 #endif
 
 /****************************************************************************
@@ -954,4 +867,5 @@
 }
 
 #endif /* !defined(DONT_USE_ALARM_THREAD) */
+#endif /* WIN */
 #endif /* MAIN */

=== modified file 'sql/CMakeLists.txt'
--- sql/CMakeLists.txt	2011-11-28 00:23:13 +0000
+++ sql/CMakeLists.txt	2011-12-10 18:32:32 +0000
@@ -31,7 +31,7 @@
 
 SET_SOURCE_FILES_PROPERTIES(${GEN_SOURCES} PROPERTIES GENERATED 1)
 
-ADD_DEFINITIONS(-DMYSQL_SERVER -DHAVE_EVENT_SCHEDULER) 
+ADD_DEFINITIONS(-DMYSQL_SERVER -DHAVE_EVENT_SCHEDULER -DHAVE_POOL_OF_THREADS) 
 IF(SSL_DEFINES)
  ADD_DEFINITIONS(${SSL_DEFINES})
 ENDIF()
@@ -82,9 +82,16 @@
                opt_index_cond_pushdown.cc opt_subselect.cc
                opt_table_elimination.cc sql_expression_cache.cc
                gcalc_slicescan.cc gcalc_tools.cc
-
+			   threadpool_common.cc 
                ${GEN_SOURCES}
-               ${MYSYS_LIBWRAP_SOURCE})
+               ${MYSYS_LIBWRAP_SOURCE}
+			   )
+  
+IF(WIN32)
+  SET(SQL_SOURCE ${SQL_SOURCE} threadpool_win.cc)
+ELSE()
+ SET(SQL_SOURCE ${SQL_SOURCE} threadpool_unix.cc)
+ENDIF()
 
 MYSQL_ADD_PLUGIN(partition ha_partition.cc STORAGE_ENGINE DEFAULT STATIC_ONLY
 RECOMPILE_FOR_EMBEDDED)

=== modified file 'sql/mysqld.cc'
--- sql/mysqld.cc	2011-12-12 22:58:40 +0000
+++ sql/mysqld.cc	2011-12-26 15:39:04 +0000
@@ -73,6 +73,7 @@
 #include <waiting_threads.h>
 #include "debug_sync.h"
 #include "sql_callback.h"
+#include "threadpool.h"
 
 #ifdef WITH_PERFSCHEMA_STORAGE_ENGINE
 #include "../storage/perfschema/pfs_server.h"
@@ -5235,6 +5236,8 @@
 
 int mysqld_main(int argc, char **argv)
 {
+  my_progname= argv[0];
+
   /*
     When several instances are running on the same machine, we
     need to have an  unique  named  hEventShudown  through the
@@ -7136,6 +7139,10 @@
   {"Tc_log_page_size",         (char*) &tc_log_page_size,       SHOW_LONG},
   {"Tc_log_page_waits",        (char*) &tc_log_page_waits,      SHOW_LONG},
 #endif
+#ifndef EMBEDDED_LIBRARY
+  {"Threadpool_idle_threads",  (char *) &tp_stats.num_waiting_threads, SHOW_INT},
+  {"Threadpool_threads",       (char *) &tp_stats.num_worker_threads, SHOW_INT},
+#endif
   {"Threads_cached",           (char*) &cached_thread_count,    SHOW_LONG_NOFLUSH},
   {"Threads_connected",        (char*) &connection_count,       SHOW_INT},
   {"Threads_created",	       (char*) &thread_created,		SHOW_LONG_NOFLUSH},
@@ -8019,7 +8026,9 @@
   else if (thread_handling == SCHEDULER_NO_THREADS)
     one_thread_scheduler(thread_scheduler);
   else
-    pool_of_threads_scheduler(thread_scheduler);  /* purecov: tested */
+    pool_of_threads_scheduler(thread_scheduler,  &max_connections,
+                                        &connection_count); 
+
   one_thread_per_connection_scheduler(extra_thread_scheduler,
                                       &extra_max_connections,
                                       &extra_connection_count);

